# Samizdat moderation log
#
#   Copyright (c) 2002-2008  Dmitry Borodaenko <angdraug@debian.org>
#
#   This program is free software.
#   You can distribute/modify this program under the terms of
#   the GNU General Public License version 2 or later.
#
# vim: et sw=2 sts=2 ts=8 tw=0

class ModerationController < Controller

  def index
    page = (@request['page'] or 1).to_i

    if @id
      resource = Resource.new(@request, @id)
      title = ', ' + resource.title
      dataset = resource.moderation_log
    else
      dataset = Moderation.find
    end

    if Moderation.find_pending.size > 0
      pending = %q{<p><a href="moderation/pending">} + _('Pending Moderation Requests') + '</a></p>'
    end

    log_table = [[_('Date'), _('Moderator'), _('Action'), _('Resource')]] +
      dataset[page - 1].collect {|date, moderator, action, resource|
        l = Moderation.new(resource, action, moderator, date)
        [
          format_date(l.date),
          l.moderator ? resource_href(l.moderator, Resource.new(@request, l.moderator).title) : '&nbsp;',
          _(Moderation::ACTION_LABELS[l.action]),
          Resource.new(@request, l.resource).list_item
        ]
      }

    @title = _('Moderation Log') + title.to_s + page_number(page)
    @content_for_layout = box(@title,
      pending.to_s + table(log_table, nav(dataset)))
  end

  def pending
    page = (@request['page'] or 1).to_i
    dataset = Moderation.find_pending

    pending_table = [[_('Date'), _('Resource')]] + 
      dataset[page - 1].collect {|action_date, resource|
        resource = Resource.new(@request, resource)
        [ format_date(action_date), resource.short + resource.buttons ]
      }

    @title = _('Pending Moderation Requests') + page_number(page)
    @content_for_layout = box(@title,
      table(pending_table, nav(dataset)))
  end
end
